<template>
  <section style="margin-bottom:20px;">
    <label v-if="label && !labelPosition" :for="id || autoId">{{ label }}</label>
    <select :id="id || autoId"  ref="selectbox" @change="ChangeValue" class="custom-select">
      <option v-if="empty" :selected="( valueField !== '[object]' ) ? inputValue === '' : inputValue === null">{{empty}}</option>
      <option v-for="option in compiledData" :value="( valueField !== '[object]' ) ? option[valueField] : option[textField]"
      :selected="( valueField !== '[object]' ) ? inputValue === option[valueField] : ( inputValue !== null ? inputValue[textField] === option[textField] : false )">{{option[textField]}}</option>
    </select>
    <label v-if="label && labelPosition" :for="id || autoId">{{ label }}</label>
  </section>
</template>

<script>

  import validatableFormControl from './validatableFormControl';

  import Vue from 'vue';

  export default Vue.component( 'selectbox', {
  
    extends : validatableFormControl,
  
    props : {
      empty : {
        type : String,
        default : null
      },
      dataSource : { 
        type : String,
        default : null
      },
      data : {
        type : Array,
        default : null
      },
      valueField : {
        type : String,
        default : "value"
      },
      textField : {
        type : String,
        default : "text"
      },
        orderBy: {
        type: String,
        default: null
      },
    },

    created(){
      if( this.dataSource !== null ){
        app.api.Get( this.dataSource ).then((response) => {
         if(this.orderBy){
            var orderBy = this.orderBy;
              response = response.sort(function (a, b) {
                if (a[orderBy] < b[orderBy])
                  return -1;
                if (a[orderBy] > b[orderBy])
                  return 1;
                return 0;
              });
            }
        this.compiledData = response
        });
      }
      else if( this.data !== null ){
        this.compiledData = this.data;
      }
    },

    methods : {
      ChangeValue(event){
       this.$emit( "input", event.target.value );
      }
    },

    data(){
      return {
        compiledData : [],
        inputValue : ''
      };
    }
  } );

</script>